// XZR (PC98) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*8*154];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d,dn=0;

	// fBXNp
	const unsigned char id1[] = { 0xfa,0xfc,0xba,0x5e,0x11,0x8e,0xd2,0x8a };
	const unsigned char id2[] = { 0x00,0x00,0x00,0x08,0x0f,0x04,0x00,0x00 };

	// ȃf[^(2HD)
	struct fpos mh[] =
	{
		{ 0x74, 0x08, 0x0400 },	// The Puppet
		{ 0x75, 0x01, 0x0400 },	// S[V
		{ 0x75, 0x02, 0x0400 },	// The Gulf Crisis
		{ 0x75, 0x03, 0x0800 },	// The White Ruffian
		{ 0x75, 0x05, 0x0400 },	// Return to Fusus
		{ 0x75, 0x06, 0x0400 },	// On y va
		{ 0x75, 0x07, 0x0400 },	// V}̋
		{ 0x75, 0x08, 0x0400 },	// ʉ
		{ 0x76, 0x01, 0x0400 },	// The Red Square
		{ 0x76, 0x02, 0x0800 },	// Dance of Dirts
		{ 0x76, 0x04, 0x0c00 },	// Parmenides with Herakleitos
		{ 0x76, 0x07, 0x0400 },	// The Mission
		{ 0x76, 0x08, 0x0400 },	// ^gD[EB[i
		{ 0x77, 0x01, 0x0800 },	// a Prologue on XZR
		{ 0x77, 0x03, 0x0400 },	// Pneuma
		{ 0x77, 0x04, 0x0800 },	// The Black Mailer
		{ 0x77, 0x06, 0x0800 },	// Elan Doll
		{ 0x77, 0x08, 0x0800 },	// Punjab
		{ 0x78, 0x02, 0x0400 },	// Upanisad
		{ 0x78, 0x03, 0x0c00 },	// Leningrad
		{ 0x78, 0x06, 0x0400 },	// ʉ
		{ 0x78, 0x07, 0x1000 },	// Sufrawaldhi
		{ 0x79, 0x03, 0x0400 },	// ʉ
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	// ȃf[^(2DD)
	struct fpos md[] =
	{
		{ 0x6b, 0x04, 0x1400 },	// v[iE[}
		{ 0x6c, 0x04, 0x1800 },	// [KEoQV
		{ 0x1c, 0x05, 0x0400 },	// The Puppet
		{ 0x1d, 0x01, 0x0400 },	// S[V
		{ 0x1d, 0x02, 0x0400 },	// The Gulf Crisis
		{ 0x1d, 0x03, 0x0800 },	// The White Ruffian
		{ 0x1d, 0x05, 0x0400 },	// Return to Fusus
		{ 0x1e, 0x01, 0x0400 },	// On y va
		{ 0x1e, 0x02, 0x0400 },	// V}̋
		{ 0x1e, 0x03, 0x0400 },	// ʉ
		{ 0x1e, 0x04, 0x0400 },	// The Red Square
		{ 0x1e, 0x05, 0x0800 },	// Dance of Dirts
		{ 0x1f, 0x02, 0x0c00 },	// Parmenides with Herakleitos
		{ 0x1f, 0x05, 0x0400 },	// The Mission
		{ 0x20, 0x01, 0x0400 },	// ^gD[EB[i
		{ 0x20, 0x02, 0x0800 },	// a Prologue on XZR
		{ 0x20, 0x04, 0x0400 },	// Pneuma
		{ 0x20, 0x05, 0x0800 },	// The Black Mailer
		{ 0x21, 0x02, 0x0800 },	// Elan Doll
		{ 0x21, 0x04, 0x0800 },	// Punjab
		{ 0x22, 0x01, 0x0400 },	// Upanisad
		{ 0x22, 0x02, 0x0c00 },	// Leningrad
		{ 0x22, 0x05, 0x0400 },	// ʉ
		{ 0x23, 0x01, 0x1000 },	// Sufrawaldhi
		{ 0x23, 0x05, 0x0400 },	// ʉ
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	if (argc<2 || argc>3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
	}

	if (argc==3)
	{
		// fBXNԍw
		dn = *argv[2]-'0';
		if (dn<1 || dn>2)
		{
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
		}
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		int media = disk.GetDiskType();
		if (media==disk.TYPE_2HD)
		{
			// 2HD
			printf("MEDIA TYPE=2HD\n");
			disk.SetRecordRange(0x01,0x08);
			disk.ReadDATA(0x48, 0x24, 0x00, 0x01, 0x03, buff, 0x400);
			// fBXN
			if ((!memcmp(buff, id1, sizeof(id1)) && dn==0) || dn==1)
			{
				fprintf(stderr, "Disk AF܂.\n");
				// hCoȃf[^؂o
				fcut("PROG",  0x48, 0x24, 0x00, 0x01, 0x03, 0x0000, 0x10000);
				fcut("MUS00", 0x2e, 0x17, 0x00, 0x07, 0x03, 0x0000, 0x1400);	// v[iE[}
				fcut("MUS01", 0x2f, 0x17, 0x01, 0x04, 0x03, 0x0000, 0x1800);	// [KEoQV
			}
			else if ((!memcmp(buff, id2, sizeof(id2)) && dn==0) || dn==2)
			{
				fprintf(stderr, "Disk BF܂.\n");
				for (i=0; mh[i].trk; i++)
				{
					sprintf(fname,"MUS%02d",i+2);
					fcut(fname, mh[i].trk, mh[i].trk>>1, mh[i].trk&1, mh[i].sec, 0x03, 0, mh[i].size);
				}
			}
		}
		else if (media==disk.TYPE_2DD)
		{
			// 2DD
			printf("MEDIA TYPE=2DD\n");
			disk.SetRecordRange(0x01,0x05);
			disk.ReadDATA(0x91, 0x48, 0x01, 0x01, 0x03, buff, 0x400);
			// fBXN
			if ((!memcmp(buff, id1, sizeof(id1)) && dn==0) || dn==1)
			{
				fprintf(stderr, "Disk AF܂.\n");
				// hCoȃf[^؂o
				fcut("PROG",  0x91, 0x48, 0x01, 0x01, 0x03, 0x0000, 0x10000);
				for (i=0; md[i].trk; i++)
				{
					sprintf(fname,"MUS%02d",i);
					fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x03, 0, md[i].size);
				}
			}
		}
	}
	return 0;
}

